var app = getApp();
var that;
import { _debounce, getCache } from '../../../utils/util'
Page({
  data: {
    tabIndex: 1,
    menuList: [
      { name: '我的绩效', icon: 'icon-fenzu', url: '../myJx/myJx', code: 'creator admin', index: 1, color: 'blue' },
      { name: '我参与的', icon: 'icon-canyu', url: '../participation/participation', code: 'admin employee', index: 2, color: 'orange' },
      { name: '报表统计', icon: 'icon-tongji', url: '../statistics/statistics', code: 'creator admin', index: 3, color: 'green' },
      { name: '全部考核', icon: 'icon-quanbu', url: '../allJx/allJx', code: 'creator admin', index: 4, color: 'blue' },
    ],
    dbList: [],
    dbTolal: 0,
    xxList: [],
    xxTolal: 0,
    userInfo: app.globalData.userData
  },
  onLoad() {
    that = this;
    dd.setNavigationBar({ title: "首页" });
    that.setData({
      userInfo: app.globalData.userData,
      role: getCache('role')
    })
    this.setR();
    this.returnS();
    this.getUserList();
  },
  onShow() {
    this.getDb()
  },
  returnS() {
    let str = "绩效主管理员"
    let role = this.data.role
    if (role == 'masterAdministrator') {
      str = "绩效主管理员"
    } else if (role == 'childAdministrator') {
      str = "绩效子管理员"
    } else if (role == 'deptManager') {
      str = "部门管理员"
    } else {
      str = "员工"
    }
    that.setData({
      str: str
    })
  },
  setR() {
    if (this.data.role == 'employee') {
      this.setData({
        menuList: [
          { name: '我的绩效', icon: 'icon-fenzu', url: '../myJx/myJx', code: 'admin', index: 1, color: 'blue' },
          { name: '我参与的', icon: 'icon-canyu', url: '../participation/participation', code: 'admin employee', index: 2, color: 'orange' },
        ],
      })
    }
  },
  getUserList() {
    app.$get("api/per/user/employee_list", { page: 0, page_size: 0 }).then((res) => {
      let list = res.data.data.list
      let data = {}
      for (let i in list) {
        data[list[i].id] = list[i];
      }
      app.globalData.usersList = data;
    })
  },
  openUrl(e) {
    // dd.chooseDingTalkDir({
    //     success: (res) => {
    //         /* data结构
    //         {"data":
    //             [
    //                 {
    //                     "spaceId": "" //被选中的空间id
    //                     "path": "", // 被选中的文件夹路径
    //                     "dirId": "", //被选中的文件夹id
    //                 }
    //             ]
    //         }
    //       */
    //     },
    //     fail: (err) =>{
    //         dd.alert({
    //             content:JSON.stringify(err)
    //         })
    //     }
    // })
    // return false
    var url = e.target.dataset.url;
    if (url == 'all') {
      dd.switchTab({
        url: '../../statistics/index/index'
      })
      return
    }
    dd.navigateTo({
      url: url
    })
  },
  openDetail(e) {
    let item = e.target.dataset.item
    if (this.data.tabIndex == 2) {
      let data = {
        id: item.id,
        type: item.type,
        employee_id: item.employee_id
      }
      dd.navigateTo({
        url: `../performanceDetails/performanceDetails?id=${item.remark.packageEmployee_id}&tel=${item.remark.package_name}&paths='messageInform'&data=${JSON.stringify(data)}`
      })
    } else {
      dd.navigateTo({
        url: `../performanceDetails/performanceDetails?id=${item.remark.packageEmployee_id}&tel=${item.remark.package_name}`
      })
    }
  },
  //代办||未读消息
  getDb() {
    var http1 = app.$get("api/per/package/msg/agency", { page: 1, page_size: 5, status: 0, node_type: 0 })
    var http2 = app.$get('api/per/package/msg/cc', { page: 1, page_size: 5, status: 0, type: '1,2' })// 获取排行榜
    Promise.all([http1, http2]).then(function (res) {
      let data1 = res[0].data.data;
      let data2 = res[1].data.data;
      data1.list.forEach(item => {
        if (item.remark.employee_id) {
          //被考核人
          item.userInfo = app.globalData.usersList[item.remark.employee_id];
        }
      });
      data2.list.forEach(item => {
        if (item.remark.employee_id) {
          //被考核人
          item.userInfo = app.globalData.usersList[item.remark.employee_id];
        }
      });
      that.setData({
        dbList: data1.list,
        dbTolal: data1.total,
        xxList: data2.list,
        xxTolal: data2.total,
      })
    })
  },
  tabAction(e) {
    let index = e.target.dataset.index
    this.setData({
      tabIndex: index
    })
  },
  openAll(e) {
    let index = e.target.dataset.index
    if (index == 1) {
      dd.navigateTo({
        url: `../backlog/backlog`
      })
    } else {
      dd.navigateTo({
        url: `../messageInform/messageInform`
      })
    }
  }
});
